# coding: utf-8

import sys
import pytest  # NOQA

from ruamel.std.pathlib import PosixPath, Path, pushd, popd  # NOQA
import ruamel.std.pathlib.json


class TestJSON(object):
    def test_json_standard(self):
        assert len(ruamel.std.pathlib.json._available_json) == 2

    def test_json(self):
        p = Path('/var/tmp/pathlib_test.json')
        p.json.dump(dict(a='b', c='d'))
        res = p.read_text()
        assert res == '{\n  "a": "b",\n  "c": "d"\n}\n'

    def test_bytes_orjson(self):
        with pytest.raises(TypeError, match='Type is not JSON serializable: bytes'):
            p = Path('test.json')
            p.json.dump(dict(a='b', c=b'd'))

    def test_bytes_std_json(self):
        with pytest.raises(TypeError, match='type bytes is not JSON serializable'):
            ruamel.std.pathlib.json.std_json_dump(dict(a='b', c=b'd'), sys.stdout)

    def test_bytes_ujson(self):
        ruamel.std.pathlib.json.add_ujson()
        with pytest.raises(TypeError, match='reject_bytes is on'):
            ruamel.std.pathlib.json._available_json[-2][0](dict(a='b', c=b'd'), sys.stdout)
